#include "data.h"
#include <stdlib.h>
#include <string.h>

void add_move(int from, int to)
{
	move *m;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=0;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=0;
}

void add_move_capture(int from, int to)
{
	move *m;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=0;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(board[to]->piece_value);
}

void add_move_ep_capture(int from, int to, int ep_victim_location)
{
	move *m;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=0;
	m->ep_location_created=0;
	m->ep_victim_location=ep_victim_location;
	m->castle=0;
	m->score=evaluatePiece(board[ep_victim_location]->piece_value);
}

void add_move_creating_ep(int from, int to, int ep_location_created)
{
	move *m;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=0;
	m->ep_location_created=ep_location_created;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(board[to]->piece_value);
}

void add_move_promote(int from, int to)
{
	move *m;

	//pawn=1, knight=2, king=3, bishop=5, rook=6 and queen=7
	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*7;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(7)-100;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*6;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(6)-100;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*5;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(5)-100;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*2;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(2)-100;

}

void add_move_capture_promote(int from, int to)
{
	move *m;

	//pawn=1, knight=2, king=3, bishop=5, rook=6 and queen=7
	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*7;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(7)-100+evaluatePiece(board[to]->piece_value);

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*6;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(6)-100+evaluatePiece(board[to]->piece_value);

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*5;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(5)-100+evaluatePiece(board[to]->piece_value);

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=(side?-1:1)*2;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=0;
	m->score=evaluatePiece(2)-100+evaluatePiece(board[to]->piece_value);

}

void add_move_castle(int from, int to, short int castle)
{
	move *m;

	m = &move_list[first_move[ply + 1]++];
	m->from=from;
	m->to=to;
	m->piece_promote=0;
	m->ep_location_created=0;
	m->ep_victim_location=0;
	m->castle=castle;
	m->score=25;
}

void generate_moves()
{
	first_move[ply + 1] = first_move[ply];
	int i;
	for (i=0;i<piece_count[side];i++)
	{
		//pawn=1, knight=2, king=3, bishop=5, rook=6 and queen=7
		int cur_loc=pieces[side][i].piece_location;
		switch(pieces[side][i].piece_value)
		{
			case 1:
			{
				if (cur_loc>95)
				{
					if(board[cur_loc+16]->piece_value==0)
						add_move_promote(cur_loc,cur_loc+16);
					if(board[cur_loc+15]->piece_value<0)
						add_move_capture_promote(cur_loc,cur_loc+15);
					if(board[cur_loc+17]->piece_value<0)
						add_move_capture_promote(cur_loc,cur_loc+17);
				}
				else
				{
					if(board[cur_loc+16]->piece_value==0)
					{
						add_move(cur_loc,cur_loc+16);
						if(cur_loc<32&&board[cur_loc+32]->piece_value==0) add_move_creating_ep(cur_loc,cur_loc+32,cur_loc+16);
					}
					if(board[cur_loc+15]->piece_value<0)
						add_move_capture(cur_loc,cur_loc+15);
					if(board[cur_loc+17]->piece_value<0)
						add_move_capture(cur_loc,cur_loc+17);
					if (ep_location)
					{
						if(ep_location==cur_loc+15)
							add_move_ep_capture(cur_loc,cur_loc+15,cur_loc-1);
						else
						if(ep_location==cur_loc+17)
							add_move_ep_capture(cur_loc,cur_loc+17,cur_loc+1);
					}
				}
				break;
			}
			case -1:
			{
				if (cur_loc<32)
				{
					if(board[cur_loc-16]->piece_value==0)
						add_move_promote(cur_loc,cur_loc-16);
					if(!((cur_loc-15)&0x88)&&(board[cur_loc-15]->piece_value>0))
						add_move_capture_promote(cur_loc,cur_loc-15);
					if(!((cur_loc-17)&0x88)&&(board[cur_loc-17]->piece_value>0))
						add_move_capture_promote(cur_loc,cur_loc-17);
				}
				else
				{
					if(board[cur_loc-16]->piece_value==0)
					{
						add_move(cur_loc,cur_loc-16);
						if(cur_loc>95&&board[cur_loc-32]->piece_value==0) add_move_creating_ep(cur_loc,cur_loc-32,cur_loc-16);
					}
					if(!((cur_loc-15)&0x88)&&(board[cur_loc-15]->piece_value>0))
						add_move_capture(cur_loc,cur_loc-15);
					if(!((cur_loc-17)&0x88)&&(board[cur_loc-17]->piece_value>0))
						add_move_capture(cur_loc,cur_loc-17);
					if (ep_location)
					{
						if(ep_location==cur_loc-15)
							add_move_ep_capture(cur_loc,cur_loc-15,cur_loc+1);
						else
						if(ep_location==cur_loc-17)
							add_move_ep_capture(cur_loc,cur_loc-17,cur_loc-1);
					}
				}
				break;
			}
			case 2:
			{
				if (!((cur_loc+14)&0x88))
					if(board[cur_loc+14]->piece_value==0) add_move(cur_loc,cur_loc+14);
					else if(board[cur_loc+14]->piece_value<0) add_move_capture(cur_loc,cur_loc+14);
				if (!((cur_loc+31)&0x88))
					if(board[cur_loc+31]->piece_value==0) add_move(cur_loc,cur_loc+31);
					else if (board[cur_loc+31]->piece_value<0) add_move_capture(cur_loc,cur_loc+31);
				if (!((cur_loc+33)&0x88))
					if(board[cur_loc+33]->piece_value==0) add_move(cur_loc,cur_loc+33);
					else if (board[cur_loc+33]->piece_value<0) add_move_capture(cur_loc,cur_loc+33);
				if (!((cur_loc+18)&0x88))
					if(board[cur_loc+18]->piece_value==0) add_move(cur_loc,cur_loc+18);
					else if (board[cur_loc+18]->piece_value<0) add_move_capture(cur_loc,cur_loc+18);
				if (!((cur_loc-14)&0x88))
					if(board[cur_loc-14]->piece_value==0) add_move(cur_loc,cur_loc-14);
					else if(board[cur_loc-14]->piece_value<0) add_move_capture(cur_loc,cur_loc-14);
				if (!((cur_loc-31)&0x88))
					if(board[cur_loc-31]->piece_value==0) add_move(cur_loc,cur_loc-31);
					else if (board[cur_loc-31]->piece_value<0) add_move_capture(cur_loc,cur_loc-31);
				if (!((cur_loc-33)&0x88))
					if(board[cur_loc-33]->piece_value==0) add_move(cur_loc,cur_loc-33);
					else if (board[cur_loc-33]->piece_value<0) add_move_capture(cur_loc,cur_loc-33);
				if (!((cur_loc-18)&0x88))
					if(board[cur_loc-18]->piece_value==0) add_move(cur_loc,cur_loc-18);
					else if (board[cur_loc-18]->piece_value<0) add_move_capture(cur_loc,cur_loc-18);
				break;
			}
			case -2:
			{
				if (!((cur_loc+14)&0x88))
					if(board[cur_loc+14]->piece_value==0) add_move(cur_loc,cur_loc+14);
					else if(board[cur_loc+14]->piece_value>0) add_move_capture(cur_loc,cur_loc+14);
				if (!((cur_loc+31)&0x88))
					if(board[cur_loc+31]->piece_value==0) add_move(cur_loc,cur_loc+31);
					else if (board[cur_loc+31]->piece_value>0) add_move_capture(cur_loc,cur_loc+31);
				if (!((cur_loc+33)&0x88))
					if(board[cur_loc+33]->piece_value==0) add_move(cur_loc,cur_loc+33);
					else if (board[cur_loc+33]->piece_value>0) add_move_capture(cur_loc,cur_loc+33);
				if (!((cur_loc+18)&0x88))
					if(board[cur_loc+18]->piece_value==0) add_move(cur_loc,cur_loc+18);
					else if (board[cur_loc+18]->piece_value>0) add_move_capture(cur_loc,cur_loc+18);
				if (!((cur_loc-14)&0x88))
					if(board[cur_loc-14]->piece_value==0) add_move(cur_loc,cur_loc-14);
					else if(board[cur_loc-14]->piece_value>0) add_move_capture(cur_loc,cur_loc-14);
				if (!((cur_loc-31)&0x88))
					if(board[cur_loc-31]->piece_value==0) add_move(cur_loc,cur_loc-31);
					else if (board[cur_loc-31]->piece_value>0) add_move_capture(cur_loc,cur_loc-31);
				if (!((cur_loc-33)&0x88))
					if(board[cur_loc-33]->piece_value==0) add_move(cur_loc,cur_loc-33);
					else if (board[cur_loc-33]->piece_value>0) add_move_capture(cur_loc,cur_loc-33);
				if (!((cur_loc-18)&0x88))
					if(board[cur_loc-18]->piece_value==0) add_move(cur_loc,cur_loc-18);
					else if (board[cur_loc-18]->piece_value>0) add_move_capture(cur_loc,cur_loc-18);
				break;
			}
			case 3:
			{
				if (!((cur_loc+15)&0x88))
					if(board[cur_loc+15]->piece_value==0) add_move(cur_loc,cur_loc+15);
					else if(board[cur_loc+15]->piece_value<0) add_move_capture(cur_loc,cur_loc+15);
				if (!((cur_loc+16)&0x88))
					if(board[cur_loc+16]->piece_value==0) add_move(cur_loc,cur_loc+16);
					else if(board[cur_loc+16]->piece_value<0) add_move_capture(cur_loc,cur_loc+16);
				if (!((cur_loc+17)&0x88))
					if(board[cur_loc+17]->piece_value==0) add_move(cur_loc,cur_loc+17);
					else if(board[cur_loc+17]->piece_value<0) add_move_capture(cur_loc,cur_loc+17);
				if (!((cur_loc+1)&0x88))
					if(board[cur_loc+1]->piece_value==0) add_move(cur_loc,cur_loc+1);
					else if(board[cur_loc+1]->piece_value<0) add_move_capture(cur_loc,cur_loc+1);
				if (!((cur_loc-15)&0x88))
					if(board[cur_loc-15]->piece_value==0) add_move(cur_loc,cur_loc-15);
					else if(board[cur_loc-15]->piece_value<0) add_move_capture(cur_loc,cur_loc-15);
				if (!((cur_loc-16)&0x88))
					if(board[cur_loc-16]->piece_value==0) add_move(cur_loc,cur_loc-16);
					else if(board[cur_loc-16]->piece_value<0) add_move_capture(cur_loc,cur_loc-16);
				if (!((cur_loc-17)&0x88))
					if(board[cur_loc-17]->piece_value==0) add_move(cur_loc,cur_loc-17);
					else if(board[cur_loc-17]->piece_value<0) add_move_capture(cur_loc,cur_loc-17);
				if (!((cur_loc-1)&0x88))
					if(board[cur_loc-1]->piece_value==0) add_move(cur_loc,cur_loc-1);
					else if(board[cur_loc-1]->piece_value<0) add_move_capture(cur_loc,cur_loc-1);
				if (board_status&1)
					if((board[5]->piece_value==0)&&(board[6]->piece_value==0))
						add_move_castle(4,6,1);
				if (board_status&2)
					if((board[3]->piece_value==0)&&(board[2]->piece_value==0)&&(board[1]->piece_value==0))
						add_move_castle(4,2,-1);
				break;
			}
			case -3:
			{
				if (!((cur_loc+15)&0x88))
					if(board[cur_loc+15]->piece_value==0) add_move(cur_loc,cur_loc+15);
					else if(board[cur_loc+15]->piece_value>0) add_move_capture(cur_loc,cur_loc+15);
				if (!((cur_loc+16)&0x88))
					if(board[cur_loc+16]->piece_value==0) add_move(cur_loc,cur_loc+16);
					else if(board[cur_loc+16]->piece_value>0) add_move_capture(cur_loc,cur_loc+16);
				if (!((cur_loc+17)&0x88))
					if(board[cur_loc+17]->piece_value==0) add_move(cur_loc,cur_loc+17);
					else if(board[cur_loc+17]->piece_value>0) add_move_capture(cur_loc,cur_loc+17);
				if (!((cur_loc+1)&0x88))
					if(board[cur_loc+1]->piece_value==0) add_move(cur_loc,cur_loc+1);
					else if(board[cur_loc+1]->piece_value>0) add_move_capture(cur_loc,cur_loc+1);
				if (!((cur_loc-15)&0x88))
					if(board[cur_loc-15]->piece_value==0) add_move(cur_loc,cur_loc-15);
					else if(board[cur_loc-15]->piece_value>0) add_move_capture(cur_loc,cur_loc-15);
				if (!((cur_loc-16)&0x88))
					if(board[cur_loc-16]->piece_value==0) add_move(cur_loc,cur_loc-16);
					else if(board[cur_loc-16]->piece_value>0) add_move_capture(cur_loc,cur_loc-16);
				if (!((cur_loc-17)&0x88))
					if(board[cur_loc-17]->piece_value==0) add_move(cur_loc,cur_loc-17);
					else if(board[cur_loc-17]->piece_value>0) add_move_capture(cur_loc,cur_loc-17);
				if (!((cur_loc-1)&0x88))
					if(board[cur_loc-1]->piece_value==0) add_move(cur_loc,cur_loc-1);
					else if(board[cur_loc-1]->piece_value>0) add_move_capture(cur_loc,cur_loc-1);
				if (board_status&4)
					if((board[117]->piece_value==0)&&(board[118]->piece_value==0))
						add_move_castle(116,118,1);
				if (board_status&8)
					if((board[115]->piece_value==0)&&(board[114]->piece_value==0)&&(board[113]->piece_value==0))
						add_move_castle(116,114,-1);
				break;
			}
			case 5:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -5:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case 6:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -6:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case 7:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -7:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) add_move(cur_loc,new_loc);
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
		}
	}
}

void generate_captures()
{
	first_move[ply + 1] = first_move[ply];
	int i;
	for (i=0;i<piece_count[side];i++)
	{
		int cur_loc=pieces[side][i].piece_location;
		switch(pieces[side][i].piece_value)
		{
			case 1:
			{
				if (cur_loc>95)
				{
					if(board[cur_loc+16]->piece_value==0)
						add_move_promote(cur_loc,cur_loc+16);
					if(board[cur_loc+15]->piece_value<0)
						add_move_capture_promote(cur_loc,cur_loc+15);
					if(board[cur_loc+17]->piece_value<0)
						add_move_capture_promote(cur_loc,cur_loc+17);
				}
				else
				{
					if(board[cur_loc+15]->piece_value<0)
						add_move_capture(cur_loc,cur_loc+15);
					if(board[cur_loc+17]->piece_value<0)
						add_move_capture(cur_loc,cur_loc+17);
					if (ep_location)
					{
						if(ep_location==cur_loc+15)
							add_move_ep_capture(cur_loc,cur_loc+15,cur_loc-1);
						else
						if(ep_location==cur_loc+17)
							add_move_ep_capture(cur_loc,cur_loc+17,cur_loc+1);
					}
				}
				break;
			}
			case -1:
			{
				if (cur_loc<32)
				{
					if(board[cur_loc-16]->piece_value==0)
						add_move_promote(cur_loc,cur_loc-16);
					if(!((cur_loc-15)&0x88)&&(board[cur_loc-15]->piece_value>0))
						add_move_capture_promote(cur_loc,cur_loc-15);
					if(!((cur_loc-17)&0x88)&&(board[cur_loc-17]->piece_value>0))
						add_move_capture_promote(cur_loc,cur_loc-17);
				}
				else
				{
					if(!((cur_loc-15)&0x88)&&(board[cur_loc-15]->piece_value>0))
						add_move_capture(cur_loc,cur_loc-15);
					if(!((cur_loc-17)&0x88)&&(board[cur_loc-17]->piece_value>0))
						add_move_capture(cur_loc,cur_loc-17);
					if (ep_location)
					{
						if(ep_location==cur_loc-15)
							add_move_ep_capture(cur_loc,cur_loc-15,cur_loc+1);
						else
						if(ep_location==cur_loc-17)
							add_move_ep_capture(cur_loc,cur_loc-17,cur_loc-1);
					}
				}
				break;
			}
			case 2:
			{
				if (!((cur_loc+14)&0x88))
					if(board[cur_loc+14]->piece_value==0) ;
					else if(board[cur_loc+14]->piece_value<0) add_move_capture(cur_loc,cur_loc+14);
				if (!((cur_loc+31)&0x88))
					if(board[cur_loc+31]->piece_value==0) ;
					else if (board[cur_loc+31]->piece_value<0) add_move_capture(cur_loc,cur_loc+31);
				if (!((cur_loc+33)&0x88))
					if(board[cur_loc+33]->piece_value==0) ;
					else if (board[cur_loc+33]->piece_value<0) add_move_capture(cur_loc,cur_loc+33);
				if (!((cur_loc+18)&0x88))
					if(board[cur_loc+18]->piece_value==0) ;
					else if (board[cur_loc+18]->piece_value<0) add_move_capture(cur_loc,cur_loc+18);
				if (!((cur_loc-14)&0x88))
					if(board[cur_loc-14]->piece_value==0) ;
					else if(board[cur_loc-14]->piece_value<0) add_move_capture(cur_loc,cur_loc-14);
				if (!((cur_loc-31)&0x88))
					if(board[cur_loc-31]->piece_value==0) ;
					else if (board[cur_loc-31]->piece_value<0) add_move_capture(cur_loc,cur_loc-31);
				if (!((cur_loc-33)&0x88))
					if(board[cur_loc-33]->piece_value==0) ;
					else if (board[cur_loc-33]->piece_value<0) add_move_capture(cur_loc,cur_loc-33);
				if (!((cur_loc-18)&0x88))
					if(board[cur_loc-18]->piece_value==0) ;
					else if (board[cur_loc-18]->piece_value<0) add_move_capture(cur_loc,cur_loc-18);
				break;
			}
			case -2:
			{
				if (!((cur_loc+14)&0x88))
					if(board[cur_loc+14]->piece_value==0) ;
					else if(board[cur_loc+14]->piece_value>0) add_move_capture(cur_loc,cur_loc+14);
				if (!((cur_loc+31)&0x88))
					if(board[cur_loc+31]->piece_value==0) ;
					else if (board[cur_loc+31]->piece_value>0) add_move_capture(cur_loc,cur_loc+31);
				if (!((cur_loc+33)&0x88))
					if(board[cur_loc+33]->piece_value==0) ;
					else if (board[cur_loc+33]->piece_value>0) add_move_capture(cur_loc,cur_loc+33);
				if (!((cur_loc+18)&0x88))
					if(board[cur_loc+18]->piece_value==0) ;
					else if (board[cur_loc+18]->piece_value>0) add_move_capture(cur_loc,cur_loc+18);
				if (!((cur_loc-14)&0x88))
					if(board[cur_loc-14]->piece_value==0) ;
					else if(board[cur_loc-14]->piece_value>0) add_move_capture(cur_loc,cur_loc-14);
				if (!((cur_loc-31)&0x88))
					if(board[cur_loc-31]->piece_value==0) ;
					else if (board[cur_loc-31]->piece_value>0) add_move_capture(cur_loc,cur_loc-31);
				if (!((cur_loc-33)&0x88))
					if(board[cur_loc-33]->piece_value==0) ;
					else if (board[cur_loc-33]->piece_value>0) add_move_capture(cur_loc,cur_loc-33);
				if (!((cur_loc-18)&0x88))
					if(board[cur_loc-18]->piece_value==0) ;
					else if (board[cur_loc-18]->piece_value>0) add_move_capture(cur_loc,cur_loc-18);
				break;
			}
			case 3:
			{
				if (!((cur_loc+15)&0x88))
					if(board[cur_loc+15]->piece_value==0) ;
					else if(board[cur_loc+15]->piece_value<0) add_move_capture(cur_loc,cur_loc+15);
				if (!((cur_loc+16)&0x88))
					if(board[cur_loc+16]->piece_value==0) ;
					else if(board[cur_loc+16]->piece_value<0) add_move_capture(cur_loc,cur_loc+16);
				if (!((cur_loc+17)&0x88))
					if(board[cur_loc+17]->piece_value==0) ;
					else if(board[cur_loc+17]->piece_value<0) add_move_capture(cur_loc,cur_loc+17);
				if (!((cur_loc+1)&0x88))
					if(board[cur_loc+1]->piece_value==0) ;
					else if(board[cur_loc+1]->piece_value<0) add_move_capture(cur_loc,cur_loc+1);
				if (!((cur_loc-15)&0x88))
					if(board[cur_loc-15]->piece_value==0) ;
					else if(board[cur_loc-15]->piece_value<0) add_move_capture(cur_loc,cur_loc-15);
				if (!((cur_loc-16)&0x88))
					if(board[cur_loc-16]->piece_value==0) ;
					else if(board[cur_loc-16]->piece_value<0) add_move_capture(cur_loc,cur_loc-16);
				if (!((cur_loc-17)&0x88))
					if(board[cur_loc-17]->piece_value==0) ;
					else if(board[cur_loc-17]->piece_value<0) add_move_capture(cur_loc,cur_loc-17);
				if (!((cur_loc-1)&0x88))
					if(board[cur_loc-1]->piece_value==0) ;
					else if(board[cur_loc-1]->piece_value<0) add_move_capture(cur_loc,cur_loc-1);
				break;
			}
			case -3:
			{
				if (!((cur_loc+15)&0x88))
					if(board[cur_loc+15]->piece_value==0) ;
					else if(board[cur_loc+15]->piece_value>0) add_move_capture(cur_loc,cur_loc+15);
				if (!((cur_loc+16)&0x88))
					if(board[cur_loc+16]->piece_value==0) ;
					else if(board[cur_loc+16]->piece_value>0) add_move_capture(cur_loc,cur_loc+16);
				if (!((cur_loc+17)&0x88))
					if(board[cur_loc+17]->piece_value==0) ;
					else if(board[cur_loc+17]->piece_value>0) add_move_capture(cur_loc,cur_loc+17);
				if (!((cur_loc+1)&0x88))
					if(board[cur_loc+1]->piece_value==0) ;
					else if(board[cur_loc+1]->piece_value>0) add_move_capture(cur_loc,cur_loc+1);
				if (!((cur_loc-15)&0x88))
					if(board[cur_loc-15]->piece_value==0) ;
					else if(board[cur_loc-15]->piece_value>0) add_move_capture(cur_loc,cur_loc-15);
				if (!((cur_loc-16)&0x88))
					if(board[cur_loc-16]->piece_value==0) ;
					else if(board[cur_loc-16]->piece_value>0) add_move_capture(cur_loc,cur_loc-16);
				if (!((cur_loc-17)&0x88))
					if(board[cur_loc-17]->piece_value==0) ;
					else if(board[cur_loc-17]->piece_value>0) add_move_capture(cur_loc,cur_loc-17);
				if (!((cur_loc-1)&0x88))
					if(board[cur_loc-1]->piece_value==0) ;
					else if(board[cur_loc-1]->piece_value>0) add_move_capture(cur_loc,cur_loc-1);
				break;
			}
			case 5:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -5:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case 6:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -6:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case 7:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value<0)) add_move_capture(cur_loc,new_loc);

				break;
			}
			case -7:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) ;
				if (!(new_loc&0x88)&&(board[new_loc]->piece_value>0)) add_move_capture(cur_loc,new_loc);

				break;
			}
		}
	}
}

//checks if a piece on the target square is attacked. there should be a piece on target or the sliders won't attack it.
short int attacked(int target)
{
	int i;
	short int isAttacked=0;

	for (i=0;i<piece_count[side];i++)
	{
		int cur_loc=pieces[side][i].piece_location;
		switch(pieces[side][i].piece_value)
		{
			case 1:
			{
				if((target==cur_loc+15)||(target==cur_loc+17)) isAttacked=1;
				break;
			}
			case -1:
			{
				if((target==cur_loc-15)||(target==cur_loc-17)) isAttacked=1;
				break;
			}
			case 2:
			case -2:
			{
				if(
					  (target==cur_loc+14)||(target==cur_loc+31)||(target==cur_loc+33)||(target==cur_loc+18)
					||(target==cur_loc-14)||(target==cur_loc-31)||(target==cur_loc-33)||(target==cur_loc-18)
				)
				isAttacked=1;
				break;
			}
			case 3:
			case -3:
			{
				if(
					  (target==cur_loc+15)||(target==cur_loc+16)||(target==cur_loc+17)||(target==cur_loc+1)
					||(target==cur_loc-15)||(target==cur_loc-16)||(target==cur_loc-17)||(target==cur_loc-1)
				)
				isAttacked=1;
				break;
			}
			case 5:
			case -5:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				break;
			}
			case 6:
			case -6:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				break;
			}
			case 7:
			case -7:
			{
				int new_loc;

				new_loc=cur_loc;
				while(!((new_loc+=16)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc+=1)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=16)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=1)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc+=15)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc+=17)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=15)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				new_loc=cur_loc;
				while(!((new_loc-=17)&0x88)&&(board[new_loc]->piece_value==0)) if (target==new_loc) {isAttacked=1;break;};
				if (target==new_loc) {isAttacked=1;break;}

				break;
			}
		}
		if (isAttacked) return 1;
	}
	return 0;
}

short int take_back()
{
	ply--;hply--;

	board[move_hist_list[hply].from]=board[move_hist_list[hply].to];
	board[move_hist_list[hply].from]->piece_location=move_hist_list[hply].from;

	if (!move_hist_list[hply].capture)
		board[move_hist_list[hply].to]=&(newBoard[move_hist_list[hply].to]);
	else
	if (move_hist_list[hply].ep_victim_location)
	{
		board[move_hist_list[hply].to]=&(newBoard[move_hist_list[hply].to]);
		pieces[side][piece_count[side]].piece_value=move_hist_list[hply].capture;
		pieces[side][piece_count[side]].piece_location=move_hist_list[hply].ep_victim_location;
		board[move_hist_list[hply].ep_victim_location]=&(pieces[side][piece_count[side]++]);
	}
	else
	{
		pieces[side][piece_count[side]].piece_value=move_hist_list[hply].capture;
		pieces[side][piece_count[side]].piece_location=move_hist_list[hply].to;
		board[move_hist_list[hply].to]=&(pieces[side][piece_count[side]++]);
	}

	if (move_hist_list[hply].piece_promote!=0)
		board[move_hist_list[hply].from]->piece_value=(side?1:-1);

	ep_location=move_hist_list[hply].ep_location;
	board_status=move_hist_list[hply].board_status;
	hash=move_hist_list[hply].hash;

	if (move_hist_list[hply].castle)	//moving the rook for castling
	{
		if (!side)	//black
		{
			if (move_hist_list[hply].castle==1)	//king side
			{
				board[119]=board[117];
				board[117]->piece_location=119;
				board[117]=&newBoard[117];
			}
			else						//queen side
			{
				board[112]=board[115];
				board[115]->piece_location=112;
				board[115]=&newBoard[115];
			}
		}
		else		//white
		{
			if (move_hist_list[hply].castle==1)	//king side
			{
				board[7]=board[5];
				board[5]->piece_location=7;
				board[5]=&newBoard[5];
			}
			else						//queen side
			{
				board[0]=board[3];
				board[3]->piece_location=0;
				board[3]=&newBoard[3];
			}
		}
	}

	if (side)
	{
		if (board[move_hist_list[hply].from]->piece_value==3) kings[0]=move_hist_list[hply].from;
	}
	else
		if (board[move_hist_list[hply].from]->piece_value==-3) kings[1]=move_hist_list[hply].from;

	side=!side;
//showHistory();showBoard();printf("===========================================\n");
	return 1;
}

short int make_move(move moveDetails)
{
	//no castle on check
	if (moveDetails.castle)
	{
		side=!side;
		if (attacked(kings[!side]))
		{
			side=!side;
			return 0;
		}
		side=!side;
	}

	move_hist_list[hply].from=moveDetails.from;
	move_hist_list[hply].to=moveDetails.to;
	move_hist_list[hply].piece_promote=moveDetails.piece_promote;
	move_hist_list[hply].ep_location=ep_location;
	move_hist_list[hply].ep_victim_location=0;
	move_hist_list[hply].board_status=board_status;
	move_hist_list[hply].castle=moveDetails.castle;
	if (ep_location=moveDetails.ep_location_created) hash ^= hash_ep[ep_location];

	if (board[moveDetails.to]->piece_value!=0)
	{
		//kill piece
		hash ^= hash_piece[board[moveDetails.to]->piece_value>0?0:1][abs(board[moveDetails.to]->piece_value)][moveDetails.to];
		move_hist_list[hply].capture=board[moveDetails.to]->piece_value;
		if (board[moveDetails.to]!=&pieces[!side][--piece_count[!side]])
		{
			board[moveDetails.to]->piece_value=pieces[!side][piece_count[!side]].piece_value;
			board[moveDetails.to]->piece_location=pieces[!side][piece_count[!side]].piece_location;
			board[board[moveDetails.to]->piece_location]=board[moveDetails.to];
		}
	}
	else
	if (moveDetails.ep_victim_location)
	{
		//kill en passant
		hash ^= hash_piece[board[moveDetails.ep_victim_location]->piece_value>0?0:1][abs(board[moveDetails.ep_victim_location]->piece_value)][moveDetails.ep_victim_location];
		move_hist_list[hply].ep_victim_location=moveDetails.ep_victim_location;
		move_hist_list[hply].capture=board[moveDetails.ep_victim_location]->piece_value;
		if (board[moveDetails.ep_victim_location]!=&pieces[!side][--piece_count[!side]])
		{
		board[moveDetails.ep_victim_location]->piece_value=pieces[!side][piece_count[!side]].piece_value;
		board[moveDetails.ep_victim_location]->piece_location=pieces[!side][piece_count[!side]].piece_location;
		board[board[moveDetails.ep_victim_location]->piece_location]=board[moveDetails.ep_victim_location];
		}
		board[moveDetails.ep_victim_location]=&(newBoard[moveDetails.ep_victim_location]);
	}
	else move_hist_list[hply].capture=0;

	hash ^= hash_piece[board[moveDetails.from]->piece_value>0?0:1][abs(board[moveDetails.from]->piece_value)][moveDetails.from];
	board[moveDetails.to]=board[moveDetails.from];
	board[moveDetails.to]->piece_location=moveDetails.to;
	if (moveDetails.piece_promote)
		board[moveDetails.to]->piece_value=moveDetails.piece_promote;
	hash ^= hash_piece[board[moveDetails.to]->piece_value>0?0:1][abs(board[moveDetails.to]->piece_value)][moveDetails.to];
	board[moveDetails.from]=&(newBoard[moveDetails.from]);

	if (moveDetails.castle)	//moving the rook for castling
	{
		if (side)	//black
		{
			if (moveDetails.castle==1)	//king side
			{
				hash ^= hash_piece[1][6][119];
				hash ^= hash_piece[1][6][117];
				board[117]=board[119];
				board[119]->piece_location=117;
				board[119]=&newBoard[119];
			}
			else						//queen side
			{
				hash ^= hash_piece[1][6][112];
				hash ^= hash_piece[1][6][115];
				board[115]=board[112];
				board[112]->piece_location=115;
				board[112]=&newBoard[112];
			}
		}
		else		//white
		{
			if (moveDetails.castle==1)	//king side
			{
				hash ^= hash_piece[0][6][7];
				hash ^= hash_piece[0][6][5];
				board[5]=board[7];
				board[7]->piece_location=5;
				board[7]=&newBoard[7];
			}
			else						//queen side
			{
				hash ^= hash_piece[0][6][0];
				hash ^= hash_piece[0][6][3];
				board[3]=board[0];
				board[0]->piece_location=3;
				board[0]=&newBoard[0];
			}
		}
	}

	move_hist_list[hply].hash=hash;

	//castle status update
	if (board_status)
	{
		switch (moveDetails.from)
		{
			case 0:
				board_status&=13;break;
			case 7:
				board_status&=14;break;
			case 112:
				board_status&=7;break;
			case 119:
				board_status&=11;break;
			case 4:
				board_status&=12;break;
			case 116:
				board_status&=3;break;
		}
		switch (moveDetails.to)		//rook captures
		{
			case 0:
				board_status&=13;break;
			case 7:
				board_status&=14;break;
			case 112:
				board_status&=7;break;
			case 119:
				board_status&=11;break;
		}
	}
	if (side)
	{
		if (board[moveDetails.to]->piece_value==-3) kings[1]=moveDetails.to;
	}
	else
		if (board[moveDetails.to]->piece_value==3) kings[0]=moveDetails.to;

	ply++;hply++;
	side=!side;
	hash ^= hash_side;

	if (attacked(kings[!side]))
	{
		take_back();
		return 0;
	}

	if (moveDetails.castle)
		if (attacked(moveDetails.from+moveDetails.castle))
		{
			take_back();
			return 0;
		}
//showHistory();showBoard();printf("===========================================\n");
	return 1;
}

