#include "data.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>

void set_hash();
int hash_rand();
void init_hash();


void showFullBoard()
{
	int i,j;
	for (j=112;j>=0;j-=16)
	{
		for (i=j;i<j+16;i++) printf("%3d=%2d ",board[i]->piece_location,board[i]->piece_value);
		printf("\n");
	}
	printf("\n");
}


void convertLocation(int location, char* algy)
{
	int file=0, rank=0;
	if (location>111) rank=8;
	else if (location>95) rank=7;
	else if (location>79) rank=6;
	else if (location>63) rank=5;
	else if (location>47) rank=4;
	else if (location>31) rank=3;
	else if (location>15) rank=2;
	else rank=1;
	file=location+1-(rank-1)*16;

	switch(file)
	{
		case 1:strcpy(algy,"a");break;
		case 2:strcpy(algy,"b");break;
		case 3:strcpy(algy,"c");break;
		case 4:strcpy(algy,"d");break;
		case 5:strcpy(algy,"e");break;
		case 6:strcpy(algy,"f");break;
		case 7:strcpy(algy,"g");break;
		case 8:strcpy(algy,"h");break;
	}
	char*temp=algy;
	temp++;
	switch(rank)
	{
		case 1:strcpy(temp,"1");break;
		case 2:strcpy(temp,"2");break;
		case 3:strcpy(temp,"3");break;
		case 4:strcpy(temp,"4");break;
		case 5:strcpy(temp,"5");break;
		case 6:strcpy(temp,"6");break;
		case 7:strcpy(temp,"7");break;
		case 8:strcpy(temp,"8");break;
	}
}

void showBoard()
{
	int i,j;
	for (j=112;j>=0;j-=16)
	{
		for (i=j;i<j+8;i++)
				switch(board[i]->piece_value)
				{
					case  1:printf("P");break;
					case -1:printf("p");break;
					case  2:printf("N");break;
					case -2:printf("n");break;
					case  3:printf("K");break;
					case -3:printf("k");break;
					case  5:printf("B");break;
					case -5:printf("b");break;
					case  6:printf("R");break;
					case -6:printf("r");break;
					case  7:printf("Q");break;
					case -7:printf("q");break;
					default:printf(".");break;
				}
		printf("\n");
	}
	if (ep_location)
	{
		char* fromAlgy = malloc(sizeof(char) * 3);
		convertLocation(ep_location,fromAlgy);
		printf("en passant at %s\n",fromAlgy);
		free(fromAlgy);
	}
	printf("\n");
}

int convertAlgy(char* file, char* rank)
{

	int location=0;
	switch(*file)
	{
		case '2':location=16;break;
		case '3':location=32;break;
		case '4':location=48;break;
		case '5':location=64;break;
		case '6':location=80;break;
		case '7':location=96;break;
		case '8':location=112;break;
	}

	switch(*rank)
	{
		case 'b':location+=1;break;
		case 'c':location+=2;break;
		case 'd':location+=3;break;
		case 'e':location+=4;break;
		case 'f':location+=5;break;
		case 'g':location+=6;break;
		case 'h':location+=7;break;
	}
	return location;

}

void convertPiece(int piece, char* pieceAlgy)
{
	switch (piece)
	{
		case 1:strcpy(pieceAlgy,"P");break;
		case 2:strcpy(pieceAlgy,"N");break;
		case 3:strcpy(pieceAlgy,"K");break;
		case 5:strcpy(pieceAlgy,"B");break;
		case 6:strcpy(pieceAlgy,"R");break;
		case 7:strcpy(pieceAlgy,"Q");break;
		case -1:strcpy(pieceAlgy,"p");break;
		case -2:strcpy(pieceAlgy,"n");break;
		case -3:strcpy(pieceAlgy,"k");break;
		case -5:strcpy(pieceAlgy,"b");break;
		case -6:strcpy(pieceAlgy,"r");break;
		case -7:strcpy(pieceAlgy,"q");break;
	}
}

void convertPiece2(int piece, char* pieceAlgy)
{
	switch (piece)
	{
		case 1:strcpy(pieceAlgy,"p");break;
		case 2:strcpy(pieceAlgy,"n");break;
		case 3:strcpy(pieceAlgy,"k");break;
		case 5:strcpy(pieceAlgy,"b");break;
		case 6:strcpy(pieceAlgy,"r");break;
		case 7:strcpy(pieceAlgy,"q");break;
		case -1:strcpy(pieceAlgy,"p");break;
		case -2:strcpy(pieceAlgy,"n");break;
		case -3:strcpy(pieceAlgy,"k");break;
		case -5:strcpy(pieceAlgy,"b");break;
		case -6:strcpy(pieceAlgy,"r");break;
		case -7:strcpy(pieceAlgy,"q");break;
	}
}

void showPV()
{
	int i,j;
	char* fromAlgy = malloc(sizeof(char) * 3);
	char* toAlgy = malloc(sizeof(char) * 3);
	char* pieceAlgy = malloc(sizeof(char) * 2);
//	for (i=0;i<10;i++)
//	{
//		printf("ply%d(%d)=",i,pv_length[i]);
		for (j=0;j<pv_length[0];j++)
		{
			move *m;
			m = &(pv[0][j]);
			if ((m->from==0)&&(m->to==0)) printf("-----\t");
			else{
			convertLocation(m->from,fromAlgy);
			convertLocation(m->to,toAlgy);
			printf("%s",fromAlgy);
			printf("%s",toAlgy);
			if (m->piece_promote!=0)
			{
				convertPiece2(m->piece_promote,pieceAlgy);
				printf("%s",pieceAlgy);
			}
			printf(" ");
			}
		}
		printf("\n");

		free(fromAlgy);
		free(toAlgy);
		free(pieceAlgy);

//	}
}

void showGenMoves()
{
	int i;
	for (i=first_move[ply];i<first_move[ply+1];i++)
	{
		char* fromAlgy = malloc(sizeof(char) * 3);
		char* toAlgy = malloc(sizeof(char) * 3);
		char* pieceAlgy = malloc(sizeof(char) * 2);

		move *m;
		m = &move_list[i];
		convertLocation(m->from,fromAlgy);
		convertLocation(m->to,toAlgy);
		printf("%s-",fromAlgy);
		printf("%s",toAlgy);
		if (m->piece_promote!=0)
		{
			convertPiece(m->piece_promote,pieceAlgy);
			printf("(%s)",pieceAlgy);
		}
		if (m->ep_victim_location!=0)
		{
			printf(" ep",pieceAlgy);
		}
		if (m->ep_location_created!=0)
		{
			printf(" [%d]",m->ep_location_created);
		}
		if (m->castle!=0)
		{
			printf(" castle");
		}
		printf("\n");

		free(fromAlgy);
		free(toAlgy);
		free(pieceAlgy);

	}
printf("----------------------------\n");

}

void showHistory()
{
	if (!hply) return;
	int i;
	for (i=0;i<hply;i++)
	{
		char* fromAlgy = malloc(sizeof(char) * 3);
		char* toAlgy = malloc(sizeof(char) * 3);
		char* pieceAlgy = malloc(sizeof(char) * 2);

		move_hist *m;
		m = &move_hist_list[i];
		convertLocation(m->from,fromAlgy);
		convertLocation(m->to,toAlgy);
		printf("%s",fromAlgy);
		printf("%s",m->capture==0?"-":"x");
		printf("%s",toAlgy);
		if (m->piece_promote!=0)
		{
			convertPiece(m->piece_promote,pieceAlgy);
			printf("(%s)",pieceAlgy);
		}
		if (m->ep_victim_location!=0)
		{
			printf(" ep",pieceAlgy);
		}
		printf(";");
		free(fromAlgy);
		free(toAlgy);
		free(pieceAlgy);
	}
	printf("\n");
}

void readFEN(char gen[])
{
	int i,j;
	for (i=0;i<128;i++) board[i]=&(newBoard[i]);
	piece_count[0]=0;
	piece_count[1]=0;
	ply=0;
	hply=0;
	side=0;
	xside=1;
	half_move_clock=0;
	full_move_number=0;
	board_status=0;
	ep_location=0;
	first_move[0]=0;

	i=112;
	for (j=0;gen[j]!=' ';j++)
	{
		switch(gen[j])
		{
			case '/':
			{
				i-=24;
				break;
			}
			case '8':i++;
			case '7':i++;
			case '6':i++;
			case '5':i++;
			case '4':i++;
			case '3':i++;
			case '2':i++;
			case '1':i++;break;
			case 'p':
			{
				pieces[1][piece_count[1]].piece_value=-1;
				pieces[1][piece_count[1]].piece_location=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'P':
			{
				pieces[0][piece_count[0]].piece_value=1;
				pieces[0][piece_count[0]].piece_location=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
			case 'n':
			{
				pieces[1][piece_count[1]].piece_value=-2;
				pieces[1][piece_count[1]].piece_location=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'N':
			{
				pieces[0][piece_count[0]].piece_value=2;
				pieces[0][piece_count[0]].piece_location=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
			case 'b':
			{
				pieces[1][piece_count[1]].piece_value=-5;
				pieces[1][piece_count[1]].piece_location=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'B':
			{
				pieces[0][piece_count[0]].piece_value=5;
				pieces[0][piece_count[0]].piece_location=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
			case 'r':
			{
				pieces[1][piece_count[1]].piece_value=-6;
				pieces[1][piece_count[1]].piece_location=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'R':
			{
				pieces[0][piece_count[0]].piece_value=6;
				pieces[0][piece_count[0]].piece_location=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
			case 'q':
			{
				pieces[1][piece_count[1]].piece_value=-7;
				pieces[1][piece_count[1]].piece_location=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'Q':
			{
				pieces[0][piece_count[0]].piece_value=7;
				pieces[0][piece_count[0]].piece_location=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
			case 'k':
			{
				pieces[1][piece_count[1]].piece_value=-3;
				pieces[1][piece_count[1]].piece_location=i;
				kings[1]=i;
				board[i++]=&pieces[1][piece_count[1]++];
				break;
			}
			case 'K':
			{
				pieces[0][piece_count[0]].piece_value=3;
				pieces[0][piece_count[0]].piece_location=i;
				kings[0]=i;
				board[i++]=&pieces[0][piece_count[0]++];
				break;
			}
		}
	}

	side=(gen[++j]=='b');
	j+=2;

	if (gen[j]=='K') {board_status|=1;j++;}
	if (gen[j]=='Q') {board_status|=2;j++;}
	if (gen[j]=='k') {board_status|=4;j++;}
	if (gen[j]=='q') {board_status|=8;j++;}
	if (gen[j]=='-') j++;

	j++;

	if (gen[j]=='-') j++;
	else ep_location=convertAlgy(&gen[j++],&gen[j++]);

	// calculate hash
	set_hash();

	if (gen[j+1]=='\0') return;

	char* hmcs = malloc(sizeof(char) * 5);int k=0;
	while (gen[++j]!=' ')
		hmcs[k++]=gen[j];
	hmcs[k]='\0';
	half_move_clock=atoi(hmcs);
	free(hmcs);

	if (gen[j+1]=='\0') return;

	char* fmn = malloc(sizeof(char) * 5);k=0;
	while (gen[++j]!=' '&&gen[j]!='\0')
		fmn[k++]=gen[j];
	fmn[k]='\0';
	full_move_number=atoi(fmn);
	free(fmn);

	if (gen[j]=='\0') return;

	if (gen[j]==' ')
	{
		int l;
		for (l=0;l<6;l++)
		{
			while (gen[++j]!=' '&&gen[j]!='\0') ;
			char* d1 = malloc(sizeof(char) * 12);k=0;
			while (gen[++j]!=' '&&gen[j]!='\0')
				d1[k++]=gen[j];
			d1[k]='\0';
			d[l]=atoi(d1);
			free(d1);
		}
	}
}

void showPieces()
{
	int i;
	char* pieceAlgy = malloc(sizeof(char) * 2);
	char* pieceLoc = malloc(sizeof(char) * 2);
	printf("White\n");
	for (i=0;i<piece_count[0];i++)
	{
		convertPiece(pieces[0][i].piece_value,pieceAlgy);
		convertLocation(pieces[0][i].piece_location,pieceLoc);
		printf("%s(%s)\n",pieceAlgy,pieceLoc);
	}
	printf("Black\n");
	for (i=0;i<piece_count[1];i++)
	{
		convertPiece(pieces[1][i].piece_value,pieceAlgy);
		convertLocation(pieces[1][i].piece_location,pieceLoc);
		printf("%s(%s)\n",pieceAlgy,pieceLoc);
	}
	free(pieceAlgy);
	free(pieceLoc);
}

int getTime()
{
	time_t t1;

	(void) time(&t1);

	return (int) t1;
}

// init_hash() initializes the hash random numbers
void init_hash()
{
	int i, j, k;

	srand(0);
	for (i = 0; i < 2; ++i)
		for (j = 0; j < 7; ++j)
			for (k = 0; k < 64; ++k)
				hash_piece[i][j][k] = hash_rand();
	hash_side = hash_rand();
	for (i = 0; i < 64; ++i)
		hash_ep[i] = hash_rand();
}


/* hash_rand() XORs some shifted random numbers together to make sure
   we have good coverage of all 32 bits. (rand() returns 16-bit numbers
   on some systems.) */

int hash_rand()
{
	int i;
	int r = 0;

	for (i = 0; i < 32; ++i)
		r ^= rand() << i;
	return r;
}

void set_hash()
{
	int i;

	hash = 0;
	for (i = 0; i < 64; ++i)
		if (board[i]->piece_value!=0)
			hash ^= hash_piece[board[i]->piece_value>0?0:1][abs(board[i]->piece_value)][i];
	if (side)
		hash ^= hash_side;
	if (ep_location)
		hash ^= hash_ep[ep_location];
}
